diff --git a/.classpath b/.classpath
index be9988d40e1e4dc55633409c0f91f1f14a643eac..5161a988a3bb038ce688a81059f7c64a8af0fcc2 100644
--- a/.classpath
+++ b/.classpath
@@ -1,22 +1,25 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <classpath>
-	<classpathentry excluding="**/CMakeLists.txt" kind="src" path="base/ca/src"/>
-	<classpathentry kind="src" path="base/test/src"/>
+	<classpathentry excluding="**/CMakeLists.txt" kind="src" path="base/test/src"/>
+	<classpathentry excluding="**/CMakeLists.txt" kind="src" path="base/symkey/src"/>
+	<classpathentry excluding="**/CMakeLists.txt" kind="src" path="base/util/src"/>
 	<classpathentry excluding="**/CMakeLists.txt" kind="src" path="base/util/test"/>
-	<classpathentry excluding="**/CMakeLists.txt" kind="src" path="base/common/test"/>
 	<classpathentry excluding="**/CMakeLists.txt" kind="src" path="base/common/src"/>
+	<classpathentry excluding="**/CMakeLists.txt" kind="src" path="base/common/test"/>
+	<classpathentry excluding="**/CMakeLists.txt" kind="src" path="base/common/functional/src"/>
 	<classpathentry excluding="**/CMakeLists.txt" kind="src" path="base/java-tools/src"/>
+	<classpathentry excluding="**/CMakeLists.txt" kind="src" path="base/server/tomcat/src"/>
+	<classpathentry excluding="**/CMakeLists.txt" kind="src" path="base/server/cms/src"/>
+	<classpathentry excluding="**/CMakeLists.txt" kind="src" path="base/server/cmscore/src"/>
+	<classpathentry excluding="**/CMakeLists.txt" kind="src" path="base/silent/src"/>
+	<classpathentry excluding="**/CMakeLists.txt" kind="src" path="base/ca/src"/>
+	<classpathentry excluding="**/CMakeLists.txt" kind="src" path="base/ca/functional/src"/>
 	<classpathentry excluding="**/CMakeLists.txt" kind="src" path="base/kra/src"/>
-	<classpathentry kind="src" path="base/migrate/80"/>
+	<classpathentry excluding="**/CMakeLists.txt" kind="src" path="base/kra/functional/src"/>
 	<classpathentry excluding="**/CMakeLists.txt" kind="src" path="base/ocsp/src"/>
-	<classpathentry excluding="**/CMakeLists.txt" kind="src" path="base/symkey/src"/>
 	<classpathentry excluding="**/CMakeLists.txt" kind="src" path="base/tks/src"/>
-	<classpathentry excluding="**/CMakeLists.txt" kind="src" path="base/util/src"/>
-	<classpathentry excluding="**/CMakeLists.txt" kind="src" path="base/silent/src"/>
-	<classpathentry kind="src" path="base/kra/functional/src"/>
-	<classpathentry kind="src" path="base/common/functional/src"/>
-	<classpathentry kind="src" path="base/ca/functional/src"/>
-	<classpathentry kind="src" path="base/tps-tomcat/src"/>
+	<classpathentry excluding="**/CMakeLists.txt" kind="src" path="base/tps-tomcat/src"/>
+	<classpathentry excluding="**/CMakeLists.txt" kind="src" path="base/migrate/80"/>
 	<classpathentry kind="con" path="org.eclipse.jdt.launching.JRE_CONTAINER"/>
 	<classpathentry kind="lib" path="/usr/share/java/apache-commons-cli.jar"/>
 	<classpathentry kind="lib" path="/usr/share/java/apache-commons-logging.jar"/>
diff --git a/base/common/src/CMakeLists.txt b/base/common/src/CMakeLists.txt
index c010bedfe809dcee3e98814083839806b936d56f..8300795eb1d88ee7a72fad0a184e6e1f5e882670 100644
--- a/base/common/src/CMakeLists.txt
+++ b/base/common/src/CMakeLists.txt
@@ -166,148 +166,6 @@ install(
 set(PKI_CERTSRV_JAR ${CMAKE_BINARY_DIR}/dist/pki-certsrv.jar CACHE INTERNAL "pki-certsrv jar file")
 
 
-# build pki-cms
-javac(pki-cms-classes
-    SOURCES
-        com/netscape/cms/*.java
-    EXCLUDE
-        com/netscape/cms/tomcat/*.java
-    CLASSPATH
-        ${PKI_NSUTIL_JAR} ${PKI_CMSUTIL_JAR}
-        ${LDAPJDK_JAR} ${SERVLET_JAR} ${VELOCITY_JAR} ${XALAN_JAR} ${XERCES_JAR}
-        ${JSS_JAR} ${COMMONS_CODEC_JAR} ${COMMONS_HTTPCLIENT_JAR}
-        ${APACHE_COMMONS_LANG_JAR}
-        ${TOMCAT_CATALINA_JAR} ${TOMCAT_UTIL_JAR} ${SYMKEY_JAR}
-        ${JAXRS_API_JAR} ${RESTEASY_JAXRS_JAR} ${RESTEASY_ATOM_PROVIDER_JAR}
-        ${HTTPCLIENT_JAR} ${HTTPCORE_JAR}
-    OUTPUT_DIR
-        ${CMAKE_BINARY_DIR}/classes
-    DEPENDS
-        pki-nsutil-jar pki-cmsutil-jar pki-certsrv-jar
-)
-
-configure_file(
-    ${CMAKE_CURRENT_SOURCE_DIR}/pki-cms.mf
-    ${CMAKE_CURRENT_BINARY_DIR}/pki-cms.mf
-)
-
-jar(pki-cms-jar
-    CREATE
-        ${CMAKE_BINARY_DIR}/dist/pki-cms.jar
-    OPTIONS
-        m
-    PARAMS
-        ${CMAKE_CURRENT_BINARY_DIR}/pki-cms.mf
-    INPUT_DIR
-        ${CMAKE_BINARY_DIR}/classes
-    FILES
-        com/netscape/cms/*.class
-    EXCLUDE
-        com/netscape/cms/tomcat/*.class
-    DEPENDS
-        pki-cms-classes
-)
-
-install(
-    FILES
-        ${CMAKE_BINARY_DIR}/dist/pki-cms.jar
-    DESTINATION
-        ${JAVA_JAR_INSTALL_DIR}/pki
-)
-
-set(PKI_CMS_JAR ${CMAKE_BINARY_DIR}/dist/pki-cms.jar CACHE INTERNAL "pki-cms jar file")
-
-
-# build pki-tomcat
-javac(pki-tomcat-classes
-    SOURCES
-        com/netscape/cms/tomcat/*.java
-    CLASSPATH
-        ${SERVLET_JAR} ${TOMCAT_CATALINA_JAR}
-    OUTPUT_DIR
-        ${CMAKE_BINARY_DIR}/classes
-    DEPENDS
-        pki-cms-jar
-)
-
-configure_file(
-    ${CMAKE_CURRENT_SOURCE_DIR}/pki-tomcat.mf
-    ${CMAKE_CURRENT_BINARY_DIR}/pki-tomcat.mf
-)
-
-jar(pki-tomcat-jar
-    CREATE
-        ${CMAKE_BINARY_DIR}/dist/pki-tomcat.jar
-    OPTIONS
-        m
-    PARAMS
-        ${CMAKE_CURRENT_BINARY_DIR}/pki-tomcat.mf
-    INPUT_DIR
-        ${CMAKE_BINARY_DIR}/classes
-    FILES
-        com/netscape/cms/tomcat/*.class
-    DEPENDS
-        pki-tomcat-classes
-)
-
-install(
-    FILES
-        ${CMAKE_BINARY_DIR}/dist/pki-tomcat.jar
-    DESTINATION
-        ${JAVA_JAR_INSTALL_DIR}/pki
-)
-
-set(PKI_TOMCAT_JAR ${CMAKE_BINARY_DIR}/dist/pki-tomcat.jar CACHE INTERNAL "pki-tomcat jar file")
-
-
-# build pki-cmscore
-javac(pki-cmscore-classes
-    SOURCES
-        com/netscape/cmscore/*.java
-    CLASSPATH
-        ${PKI_NSUTIL_JAR} ${PKI_CMSUTIL_JAR} ${PKI_TOMCAT_JAR}
-        ${LDAPJDK_JAR} ${SERVLET_JAR} ${VELOCITY_JAR} ${XALAN_JAR} ${XERCES_JAR}
-        ${JSS_JAR} ${COMMONS_CODEC_JAR} ${COMMONS_HTTPCLIENT_JAR}
-        ${APACHE_COMMONS_LANG_JAR}
-        ${TOMCAT_CATALINA_JAR} ${TOMCAT_UTIL_JAR} ${SYMKEY_JAR}
-        ${JAXRS_API_JAR} ${RESTEASY_JAXRS_JAR} ${RESTEASY_ATOM_PROVIDER_JAR}
-        ${HTTPCLIENT_JAR} ${HTTPCORE_JAR}
-    OUTPUT_DIR
-        ${CMAKE_BINARY_DIR}/classes
-    DEPENDS
-        pki-nsutil-jar pki-cmsutil-jar pki-certsrv-jar pki-cms-jar pki-tomcat-jar
-)
-
-configure_file(
-    ${CMAKE_CURRENT_SOURCE_DIR}/pki-cmscore.mf
-    ${CMAKE_CURRENT_BINARY_DIR}/pki-cmscore.mf
-)
-
-jar(pki-cmscore-jar
-    CREATE
-        ${CMAKE_BINARY_DIR}/dist/pki-cmscore.jar
-    OPTIONS
-        m
-    PARAMS
-        ${CMAKE_CURRENT_BINARY_DIR}/pki-cmscore.mf
-    INPUT_DIR
-        ${CMAKE_BINARY_DIR}/classes
-    FILES
-        com/netscape/cmscore/*.class
-    DEPENDS
-        pki-cmscore-classes
-)
-
-install(
-    FILES
-        ${CMAKE_BINARY_DIR}/dist/pki-cmscore.jar
-    DESTINATION
-        ${JAVA_JAR_INSTALL_DIR}/pki
-)
-
-set(PKI_CMSCORE_JAR ${CMAKE_BINARY_DIR}/dist/pki-cmscore.jar CACHE INTERNAL "pki-cmscore jar file")
-
-
 # build pki-cmsbundle
 configure_file(
     ${CMAKE_CURRENT_SOURCE_DIR}/pki-cmsbundle.mf
diff --git a/base/server/CMakeLists.txt b/base/server/CMakeLists.txt
index e8f78c4fc02f40bc169b2b78dd45a2499fbf04ec..8f1391a73e3f5c4f6719a34091ad4757f9b99c96 100644
--- a/base/server/CMakeLists.txt
+++ b/base/server/CMakeLists.txt
@@ -139,3 +139,7 @@ install(
 # install empty directories
 install(CODE "file(MAKE_DIRECTORY \$ENV{DESTDIR}${VAR_INSTALL_DIR}/lock/pki)")
 install(CODE "file(MAKE_DIRECTORY \$ENV{DESTDIR}${VAR_INSTALL_DIR}/run/pki)")
+
+add_subdirectory(tomcat)
+add_subdirectory(cms)
+add_subdirectory(cmscore)
diff --git a/base/server/cms/CMakeLists.txt b/base/server/cms/CMakeLists.txt
new file mode 100644
index 0000000000000000000000000000000000000000..735ca31a89fdb6db51be6b0c0efca0e490355238
--- /dev/null
+++ b/base/server/cms/CMakeLists.txt
@@ -0,0 +1,3 @@
+project(cms)
+
+add_subdirectory(src)
diff --git a/base/server/cms/src/CMakeLists.txt b/base/server/cms/src/CMakeLists.txt
new file mode 100644
index 0000000000000000000000000000000000000000..16fa1fe8abf517b78aebbbf67c3fc3d2d78f6a4e
--- /dev/null
+++ b/base/server/cms/src/CMakeLists.txt
@@ -0,0 +1,168 @@
+project(pki-cms)
+
+find_file(JSS_JAR
+    NAMES
+        jss4.jar
+    PATHS
+        ${JAVA_LIB_INSTALL_DIR}
+        /usr/share/java
+)
+
+find_file(LDAPJDK_JAR
+    NAMES
+        ldapjdk.jar
+    PATHS
+        ${JAVA_LIB_INSTALL_DIR}
+        /usr/share/java
+)
+
+find_file(COMMONS_CODEC_JAR
+    NAMES
+        commons-codec.jar
+    PATHS
+        /usr/share/java
+)
+
+find_file(COMMONS_HTTPCLIENT_JAR
+    NAMES
+        commons-httpclient.jar
+    PATHS
+        /usr/share/java
+)
+
+find_file(APACHE_COMMONS_LANG_JAR
+    NAMES
+        apache-commons-lang.jar
+    PATHS
+        /usr/share/java
+)
+
+find_file(TOMCAT_CATALINA_JAR
+    NAMES
+        catalina.jar
+    PATHS
+        /usr/share/java/tomcat
+)
+
+find_file(TOMCAT_UTIL_JAR
+    NAMES
+        tomcat-util.jar
+    PATHS
+        /usr/share/java/tomcat
+)
+
+find_file(SERVLET_JAR
+    NAMES
+        servlet.jar
+    PATHS
+        ${JAVA_LIB_INSTALL_DIR}
+        /usr/share/java
+)
+
+find_file(VELOCITY_JAR
+    NAMES
+        velocity.jar
+    PATHS
+        ${JAVA_LIB_INSTALL_DIR}
+        /usr/share/java
+)
+
+find_file(XALAN_JAR
+    NAMES
+        xalan-j2.jar
+    PATHS
+        ${JAVA_LIB_INSTALL_DIR}
+        /usr/share/java
+)
+
+find_file(XERCES_JAR
+    NAMES
+        xerces-j2.jar
+    PATHS
+        ${JAVA_LIB_INSTALL_DIR}
+        /usr/share/java
+)
+
+find_file(JAXRS_API_JAR
+    NAMES
+        jaxrs-api.jar
+    PATHS
+        ${RESTEASY_LIB}
+)
+
+find_file(RESTEASY_JAXRS_JAR
+    NAMES
+        resteasy-jaxrs.jar
+    PATHS
+        ${RESTEASY_LIB}
+)
+
+find_file(RESTEASY_ATOM_PROVIDER_JAR
+    NAMES
+        resteasy-atom-provider.jar
+    PATHS
+        ${RESTEASY_LIB}
+)
+
+find_file(HTTPCLIENT_JAR
+    NAMES
+        httpclient.jar
+    PATHS
+        /usr/share/java/httpcomponents
+)
+
+find_file(HTTPCORE_JAR
+    NAMES
+        httpcore.jar
+    PATHS
+        /usr/share/java/httpcomponents
+)
+
+# build pki-cms
+javac(pki-cms-classes
+    SOURCES
+        com/netscape/cms/*.java
+    CLASSPATH
+        ${PKI_NSUTIL_JAR} ${PKI_CMSUTIL_JAR} ${PKI_CERTSRV_JAR} ${PKI_TOMCAT_JAR}
+        ${LDAPJDK_JAR} ${SERVLET_JAR} ${VELOCITY_JAR} ${XALAN_JAR} ${XERCES_JAR}
+        ${JSS_JAR} ${COMMONS_CODEC_JAR} ${COMMONS_HTTPCLIENT_JAR}
+        ${APACHE_COMMONS_LANG_JAR}
+        ${TOMCAT_CATALINA_JAR} ${TOMCAT_UTIL_JAR} ${SYMKEY_JAR}
+        ${JAXRS_API_JAR} ${RESTEASY_JAXRS_JAR} ${RESTEASY_ATOM_PROVIDER_JAR}
+        ${HTTPCLIENT_JAR} ${HTTPCORE_JAR}
+    OUTPUT_DIR
+        ${CMAKE_BINARY_DIR}/classes
+    DEPENDS
+        pki-nsutil-jar pki-cmsutil-jar pki-certsrv-jar pki-tomcat-jar
+)
+
+configure_file(
+    ${CMAKE_CURRENT_SOURCE_DIR}/pki-cms.mf
+    ${CMAKE_CURRENT_BINARY_DIR}/pki-cms.mf
+)
+
+jar(pki-cms-jar
+    CREATE
+        ${CMAKE_BINARY_DIR}/dist/pki-cms.jar
+    OPTIONS
+        m
+    PARAMS
+        ${CMAKE_CURRENT_BINARY_DIR}/pki-cms.mf
+    INPUT_DIR
+        ${CMAKE_BINARY_DIR}/classes
+    FILES
+        com/netscape/cms/*.class
+    EXCLUDE
+        com/netscape/cms/tomcat/*.class
+    DEPENDS
+        pki-cms-classes
+)
+
+install(
+    FILES
+        ${CMAKE_BINARY_DIR}/dist/pki-cms.jar
+    DESTINATION
+        ${JAVA_JAR_INSTALL_DIR}/pki
+)
+
+set(PKI_CMS_JAR ${CMAKE_BINARY_DIR}/dist/pki-cms.jar CACHE INTERNAL "pki-cms jar file")
diff --git a/base/server/cmscore/CMakeLists.txt b/base/server/cmscore/CMakeLists.txt
new file mode 100644
index 0000000000000000000000000000000000000000..62ef6ec1855e6b6bdad59fa50943dd94bc79dd76
--- /dev/null
+++ b/base/server/cmscore/CMakeLists.txt
@@ -0,0 +1,3 @@
+project(cmscore)
+
+add_subdirectory(src)
diff --git a/base/server/cmscore/src/CMakeLists.txt b/base/server/cmscore/src/CMakeLists.txt
new file mode 100644
index 0000000000000000000000000000000000000000..94f5f138c4e48161392412770d85dbe1a0c8f28d
--- /dev/null
+++ b/base/server/cmscore/src/CMakeLists.txt
@@ -0,0 +1,166 @@
+project(pki-cmscore)
+
+find_file(JSS_JAR
+    NAMES
+        jss4.jar
+    PATHS
+        ${JAVA_LIB_INSTALL_DIR}
+        /usr/share/java
+)
+
+find_file(LDAPJDK_JAR
+    NAMES
+        ldapjdk.jar
+    PATHS
+        ${JAVA_LIB_INSTALL_DIR}
+        /usr/share/java
+)
+
+find_file(COMMONS_CODEC_JAR
+    NAMES
+        commons-codec.jar
+    PATHS
+        /usr/share/java
+)
+
+find_file(COMMONS_HTTPCLIENT_JAR
+    NAMES
+        commons-httpclient.jar
+    PATHS
+        /usr/share/java
+)
+
+find_file(APACHE_COMMONS_LANG_JAR
+    NAMES
+        apache-commons-lang.jar
+    PATHS
+        /usr/share/java
+)
+
+find_file(TOMCAT_CATALINA_JAR
+    NAMES
+        catalina.jar
+    PATHS
+        /usr/share/java/tomcat
+)
+
+find_file(TOMCAT_UTIL_JAR
+    NAMES
+        tomcat-util.jar
+    PATHS
+        /usr/share/java/tomcat
+)
+
+find_file(SERVLET_JAR
+    NAMES
+        servlet.jar
+    PATHS
+        ${JAVA_LIB_INSTALL_DIR}
+        /usr/share/java
+)
+
+find_file(VELOCITY_JAR
+    NAMES
+        velocity.jar
+    PATHS
+        ${JAVA_LIB_INSTALL_DIR}
+        /usr/share/java
+)
+
+find_file(XALAN_JAR
+    NAMES
+        xalan-j2.jar
+    PATHS
+        ${JAVA_LIB_INSTALL_DIR}
+        /usr/share/java
+)
+
+find_file(XERCES_JAR
+    NAMES
+        xerces-j2.jar
+    PATHS
+        ${JAVA_LIB_INSTALL_DIR}
+        /usr/share/java
+)
+
+find_file(JAXRS_API_JAR
+    NAMES
+        jaxrs-api.jar
+    PATHS
+        ${RESTEASY_LIB}
+)
+
+find_file(RESTEASY_JAXRS_JAR
+    NAMES
+        resteasy-jaxrs.jar
+    PATHS
+        ${RESTEASY_LIB}
+)
+
+find_file(RESTEASY_ATOM_PROVIDER_JAR
+    NAMES
+        resteasy-atom-provider.jar
+    PATHS
+        ${RESTEASY_LIB}
+)
+
+find_file(HTTPCLIENT_JAR
+    NAMES
+        httpclient.jar
+    PATHS
+        /usr/share/java/httpcomponents
+)
+
+find_file(HTTPCORE_JAR
+    NAMES
+        httpcore.jar
+    PATHS
+        /usr/share/java/httpcomponents
+)
+
+# build pki-cmscore
+javac(pki-cmscore-classes
+    SOURCES
+        com/netscape/cmscore/*.java
+    CLASSPATH
+        ${PKI_NSUTIL_JAR} ${PKI_CMSUTIL_JAR} ${PKI_CERTSRV_JAR} ${PKI_CMS_JAR} ${PKI_TOMCAT_JAR}
+        ${LDAPJDK_JAR} ${SERVLET_JAR} ${VELOCITY_JAR} ${XALAN_JAR} ${XERCES_JAR}
+        ${JSS_JAR} ${COMMONS_CODEC_JAR} ${COMMONS_HTTPCLIENT_JAR}
+        ${APACHE_COMMONS_LANG_JAR}
+        ${TOMCAT_CATALINA_JAR} ${TOMCAT_UTIL_JAR} ${SYMKEY_JAR}
+        ${JAXRS_API_JAR} ${RESTEASY_JAXRS_JAR} ${RESTEASY_ATOM_PROVIDER_JAR}
+        ${HTTPCLIENT_JAR} ${HTTPCORE_JAR}
+    OUTPUT_DIR
+        ${CMAKE_BINARY_DIR}/classes
+    DEPENDS
+        pki-nsutil-jar pki-cmsutil-jar pki-certsrv-jar pki-cms-jar pki-tomcat-jar
+)
+
+configure_file(
+    ${CMAKE_CURRENT_SOURCE_DIR}/pki-cmscore.mf
+    ${CMAKE_CURRENT_BINARY_DIR}/pki-cmscore.mf
+)
+
+jar(pki-cmscore-jar
+    CREATE
+        ${CMAKE_BINARY_DIR}/dist/pki-cmscore.jar
+    OPTIONS
+        m
+    PARAMS
+        ${CMAKE_CURRENT_BINARY_DIR}/pki-cmscore.mf
+    INPUT_DIR
+        ${CMAKE_BINARY_DIR}/classes
+    FILES
+        com/netscape/cmscore/*.class
+    DEPENDS
+        pki-cmscore-classes
+)
+
+install(
+    FILES
+        ${CMAKE_BINARY_DIR}/dist/pki-cmscore.jar
+    DESTINATION
+        ${JAVA_JAR_INSTALL_DIR}/pki
+)
+
+set(PKI_CMSCORE_JAR ${CMAKE_BINARY_DIR}/dist/pki-cmscore.jar CACHE INTERNAL "pki-cmscore jar file")
diff --git a/base/server/tomcat/CMakeLists.txt b/base/server/tomcat/CMakeLists.txt
new file mode 100644
index 0000000000000000000000000000000000000000..555a9329dae47e5c38f072dce009078db17c819e
--- /dev/null
+++ b/base/server/tomcat/CMakeLists.txt
@@ -0,0 +1,3 @@
+project(tomcat)
+
+add_subdirectory(src)
diff --git a/base/server/tomcat/src/CMakeLists.txt b/base/server/tomcat/src/CMakeLists.txt
new file mode 100644
index 0000000000000000000000000000000000000000..d9808a8033e2c43a4653652f74e6e9b687be8e62
--- /dev/null
+++ b/base/server/tomcat/src/CMakeLists.txt
@@ -0,0 +1,158 @@
+project(pki-tomcat)
+
+find_file(JSS_JAR
+    NAMES
+        jss4.jar
+    PATHS
+        ${JAVA_LIB_INSTALL_DIR}
+        /usr/share/java
+)
+
+find_file(LDAPJDK_JAR
+    NAMES
+        ldapjdk.jar
+    PATHS
+        ${JAVA_LIB_INSTALL_DIR}
+        /usr/share/java
+)
+
+find_file(COMMONS_CODEC_JAR
+    NAMES
+        commons-codec.jar
+    PATHS
+        /usr/share/java
+)
+
+find_file(COMMONS_HTTPCLIENT_JAR
+    NAMES
+        commons-httpclient.jar
+    PATHS
+        /usr/share/java
+)
+
+find_file(APACHE_COMMONS_LANG_JAR
+    NAMES
+        apache-commons-lang.jar
+    PATHS
+        /usr/share/java
+)
+
+find_file(TOMCAT_CATALINA_JAR
+    NAMES
+        catalina.jar
+    PATHS
+        /usr/share/java/tomcat
+)
+
+find_file(TOMCAT_UTIL_JAR
+    NAMES
+        tomcat-util.jar
+    PATHS
+        /usr/share/java/tomcat
+)
+
+find_file(SERVLET_JAR
+    NAMES
+        servlet.jar
+    PATHS
+        ${JAVA_LIB_INSTALL_DIR}
+        /usr/share/java
+)
+
+find_file(VELOCITY_JAR
+    NAMES
+        velocity.jar
+    PATHS
+        ${JAVA_LIB_INSTALL_DIR}
+        /usr/share/java
+)
+
+find_file(XALAN_JAR
+    NAMES
+        xalan-j2.jar
+    PATHS
+        ${JAVA_LIB_INSTALL_DIR}
+        /usr/share/java
+)
+
+find_file(XERCES_JAR
+    NAMES
+        xerces-j2.jar
+    PATHS
+        ${JAVA_LIB_INSTALL_DIR}
+        /usr/share/java
+)
+
+find_file(JAXRS_API_JAR
+    NAMES
+        jaxrs-api.jar
+    PATHS
+        ${RESTEASY_LIB}
+)
+
+find_file(RESTEASY_JAXRS_JAR
+    NAMES
+        resteasy-jaxrs.jar
+    PATHS
+        ${RESTEASY_LIB}
+)
+
+find_file(RESTEASY_ATOM_PROVIDER_JAR
+    NAMES
+        resteasy-atom-provider.jar
+    PATHS
+        ${RESTEASY_LIB}
+)
+
+find_file(HTTPCLIENT_JAR
+    NAMES
+        httpclient.jar
+    PATHS
+        /usr/share/java/httpcomponents
+)
+
+find_file(HTTPCORE_JAR
+    NAMES
+        httpcore.jar
+    PATHS
+        /usr/share/java/httpcomponents
+)
+
+# build pki-tomcat
+javac(pki-tomcat-classes
+    SOURCES
+        com/netscape/cms/tomcat/*.java
+    CLASSPATH
+        ${SERVLET_JAR} ${TOMCAT_CATALINA_JAR}
+    OUTPUT_DIR
+        ${CMAKE_BINARY_DIR}/classes
+)
+
+configure_file(
+    ${CMAKE_CURRENT_SOURCE_DIR}/pki-tomcat.mf
+    ${CMAKE_CURRENT_BINARY_DIR}/pki-tomcat.mf
+)
+
+jar(pki-tomcat-jar
+    CREATE
+        ${CMAKE_BINARY_DIR}/dist/pki-tomcat.jar
+    OPTIONS
+        m
+    PARAMS
+        ${CMAKE_CURRENT_BINARY_DIR}/pki-tomcat.mf
+    INPUT_DIR
+        ${CMAKE_BINARY_DIR}/classes
+    FILES
+        com/netscape/cms/tomcat/*.class
+    DEPENDS
+        pki-tomcat-classes
+)
+
+install(
+    FILES
+        ${CMAKE_BINARY_DIR}/dist/pki-tomcat.jar
+    DESTINATION
+        ${JAVA_JAR_INSTALL_DIR}/pki
+)
+
+set(PKI_TOMCAT_JAR ${CMAKE_BINARY_DIR}/dist/pki-tomcat.jar CACHE INTERNAL "pki-tomcat jar file")
